﻿; ==============================================================================
; Name ..........: Custom Menu & Page Display Gui Example
; Description ...: An example of custom menu and page display.
; AHK Version ...: AHK_L 1.1.22.09 (Unicode 32-bit) - November 11, 2015
; Win Version ...: Windows 2000+
; Language ......: English (en-US)
; Author ........: TheDewd
; Licence .......: Unlicense <http://www.unlicense.org>
; Modified ......: 2015-11-16T01:28:00-05:00 (ISO 8601)
; ==============================================================================
; @Ahk2Exe-SetName Custom Menu & Page Display Gui Example
; @Ahk2Exe-SetDescription An example of custom menu and page display.
; @Ahk2Exe-SetVersion 0.1
; @Ahk2Exe-SetCopyright Copyright (C) 2015`, TheDewd
; @Ahk2Exe-SetOrigFilename CustomMenu&PageDisplay.ahk
; ==============================================================================

; Changelog ====================================================================
; Legend: (+) NEW, (*) CHANGED, (!) FIXED
; ------------------------------------------------------------------------------
; 2015-11-16  TheDewd
; + Initial Release
; ==============================================================================

; Global =======================================================================
#SingleInstance, Force ; Allow only one running instance of script
#Persistent ; Keep script permanently running until terminated
#NoEnv ; Avoid checking empty variables to see if they're environment variables
#Warn ; Enable warnings to assist with detecting common errors
;#NoTrayIcon ; Disable the tray icon of the script
SendMode, Input ; Method for sending keystrokes and mouse clicks
SetWorkingDir, %A_ScriptDir% ; Set the working directory of the script
SetBatchLines, -1 ; Run script at maximum speed
SetWinDelay, -1 ; Sets the delay to occur after modifying the window
SetControlDelay, -1 ; Sets the delay to occur after modifying a control
OnExit, ExitSub ; Run a subroutine or function when the script exits

Application :=	{Name: ["New Script"]
				,Version: ["0.1"]}

Gui :=			{Name: [(Application.Name[1])]
				,Size: ["600", "400"]}

Menu :=			{ID: ["1", "2", "3", "4", "5", "6", "7"]
				,Name: ["Menu 01", "Menu 02", "Menu 03", "Menu 04", "Menu 05", "Menu 06", "Menu 07"]
				,Status: ["Menu 01...", "Menu 02...", "Menu 03...", "Menu 04...", "Menu 05...", "Menu 06...", "Menu 07..."]}

Page :=			{ID: ["1", "2", "3", "4", "5", "6", "7"]
				,Name: ["Page 01", "Page 02", "Page 03", "Page 04", "Page 05", "Page 06", "Page 07"]}

StatusBar :=		{ID: ["1", "2", "3"]
				,Item: ["Selection 01", "Selection 02", "Selection 03"]
				,Status: ["Change icon options..."]}
; ==============================================================================

; Script =======================================================================
Menu, Tray, Icon, Shell32.dll, 174
Menu, Tray, Tip, % Application.Name[1]
Menu, Tray, NoStandard
Menu, Tray, Add, Exit, ExitSub

Menu, StatusBarIcon, Add, % StatusBar.Item[1], MenuHandler
Menu, StatusBarIcon, Add, % StatusBar.Item[2], MenuHandler
Menu, StatusBarIcon, Add, % StatusBar.Item[3], MenuHandler

Gui, +LastFound -Resize
hGui1 := WinExist()
Gui, Color, FFFFFF
Gui, Margin, 10, 10

; Menu Indicators
Gui, Add, Picture, % "x" -999999 " y" -999999 " w" 4 " h" 32 " HWNDhMenuHover", % "resources\menu-hover.png"
Gui, Add, Picture, % "x" -999999 " y" -999999 " w" 4 " h" 32 " HWNDhMenuSelect", % "resources\menu-select.png"

; Menu Items
Gui, Font, s9 c808080, Segoe UI ; Set Font Options
Loop, % Menu.Name.Length()
{
	Gui, Add, Text, % "x" 18 " y" (32 * A_Index) - 16 " w" 120 " h" 32 " +0x200 HWNDhMenuOption" A_Index " vMenuOption" A_Index, % Menu.Name[A_Index]
}

; Page Header
Gui, Font, s11 c000000, Segoe UI ; Set Font Options
Gui, Add, Text, % "x" 156 " y" 16 " w" Gui.Size[1]-174 " h" 32 " -Border +0x200 vPageTitle",
Gui, Add, Picture, % "x" 156 " y" 50 " w" Gui.Size[1]-174 " h" 1 " -Border", % "resources\divider-horz.png"

; Page Items
Gui, Font, s9 c000000, Segoe UI ; Set Font Options
Loop, % Menu.Name.Length()
{
	Gui, Add, Text, % "x" 156 " y" 56 + (20 * A_Index) - 20 " w" Gui.Size[1]-174 " h" 20 " Hidden1 vPage1Item" A_Index, % "Lorem ipsum dolor sit amet, consectetur adipiscing elit."
	Gui, Add, Text, % "x" 156 " y" 56 + (20 * A_Index) - 20 " w" Gui.Size[1]-174 " h" 20 " Hidden1 vPage2Item" A_Index, % "Maecenas in nunc quis mauris luctus pharetra sed et ante."
	Gui, Add, Text, % "x" 156 " y" 56 + (20 * A_Index) - 20 " w" Gui.Size[1]-174 " h" 20 " Hidden1 vPage3Item" A_Index, % "Aliquam a turpis maximus, ultrices elit sed, porttitor urna."
	Gui, Add, Text, % "x" 156 " y" 56 + (20 * A_Index) - 20 " w" Gui.Size[1]-174 " h" 20 " Hidden1 vPage4Item" A_Index, % "Vestibulum maximus arcu pulvinar, volutpat metus vitae, aliquet sem."
	Gui, Add, Text, % "x" 156 " y" 56 + (20 * A_Index) - 20 " w" Gui.Size[1]-174 " h" 20 " Hidden1 vPage5Item" A_Index, % "Pellentesque vestibulum nulla convallis convallis blandit."
	Gui, Add, Text, % "x" 156 " y" 56 + (20 * A_Index) - 20 " w" Gui.Size[1]-174 " h" 20 " Hidden1 vPage6Item" A_Index, % "Vivamus sed urna pellentesque felis placerat scelerisque vitae at velit."
	Gui, Add, Text, % "x" 156 " y" 56 + (20 * A_Index) - 20 " w" Gui.Size[1]-174 " h" 20 " Hidden1 vPage7Item" A_Index, % "Mauris imperdiet odio id euismod aliquet."
}

; StatusBar
Gui, Font, s9 c808080, Segoe UI ; Set Font Options
Gui, Add, Picture, % "x" 0 " y" Gui.Size[2]-33 " w" Gui.Size[1] " h" 33 " HWNDhStatusBar", % "resources\sb-background.png"
Gui, Add, Text, % "x" 8 " y" Gui.Size[2]-32 " w" Gui.Size[1]-148 " h" 32 " HWNDhSBTextStatus vSBTextStatus +0x200", % ""
Gui, Add, Text, % "x" Gui.Size[1]-140 " y" Gui.Size[2]-32 " w" 100 " h" 32 " vSBTextIcon HWNDhSBTextIcon +0x202", % StatusBar.Item[1]
Gui, Add, Picture, % "x" Gui.Size[1]-32 " y" Gui.Size[2]-32 " w" 32 " h" 32 " HWNDhSBIcon vSBIcon", % "resources\sb-icon.png"

Gui, Show, % " w" Gui.Size[1] " h" Gui.Size[2], % Gui.Name[1]

SetMenuSelect(1) ; Menu to select at start

OnMessage(0x200, "WM_MOUSEMOVE")
OnMessage(0x2A3, "WM_MOUSELEAVE")
OnMessage(0x202, "WM_LBUTTONUP")

VarSetCapacity(TME, 16, 0), NumPut(16, TME, 0), NumPut(2, TME, 4), NumPut(hGui1, TME, 8)
return ; End automatic execution
; ==============================================================================

; Labels =======================================================================
MenuHandler:
	If (A_ThisMenu = "StatusBarIcon")
	{
		; Toggle Checkmarks
		Loop, % StatusBar.ID.Length()
		{
			Menu, StatusBarIcon, Uncheck, % StatusBar.Item[A_Index] ; Uncheck All
		}

		Menu, StatusBarIcon, Check, % StatusBar.Item[A_ThisMenuItemPos] ; Check Selected Item

		GuiControl,, SBTextIcon, % StatusBar.Item[A_ThisMenuItemPos] ; Set StatusBar Icon Text

		; Perform Specific Actions
		If (A_ThisMenuItem = StatusBar.Item[1])
		{
			TrayTip, StatusBar, % "Selected: " StatusBar.Item[1]
		}
		Else If (A_ThisMenuItem = StatusBar.Item[2])
		{
			TrayTip, StatusBar, % "Selected: " StatusBar.Item[2]
		}
		Else If (A_ThisMenuItem = StatusBar.Item[3])
		{
			TrayTip, StatusBar, % "Selected: " StatusBar.Item[3]
		}
	}
return

GuiEscape:
GuiClose:
ExitSub:
	ExitApp ; Terminate the script unconditionally
return
; ==============================================================================

; Functions ====================================================================
WM_MOUSEMOVE(wParam, lParam, Msg, Hwnd)
{
	Global

	DllCall("TrackMouseEvent", "uint", &TME)

	MouseGetPos,,,, MouseCtrl, 2

	; Set StatusBar Text
	If (MouseCtrl = hMenuOption1)
	{
		SetSBText(Menu.Status[1])
	}
	Else If (MouseCtrl = hMenuOption2)
	{
		SetSBText(Menu.Status[2])
	}
	Else If (MouseCtrl = hMenuOption3)
	{
		SetSBText(Menu.Status[3])
	}
	Else If (MouseCtrl = hMenuOption4)
	{
		SetSBText(Menu.Status[4])
	}
	Else If (MouseCtrl = hMenuOption5)
	{
		SetSBText(Menu.Status[5])
	}
	Else If (MouseCtrl = hMenuOption6)
	{
		SetSBText(Menu.Status[6])
	}
	Else If (MouseCtrl = hMenuOption7)
	{
		SetSBText(Menu.Status[7])
	}
	Else If (MouseCtrl = hSBIcon)
	{
		SetSBText(StatusBar.Status[1])
	}
	Else
	{
		SetSBText("")
	}

	; Set Menu Hover Indicator
	If (MouseCtrl = hMenuOption1 && MenuSelect != 1)
	{
		SetMenuHover(1)
	}
	Else If (MouseCtrl = hMenuOption2 && MenuSelect != 2)
	{
		SetMenuHover(2)
	}
	Else If (MouseCtrl = hMenuOption3 && MenuSelect != 3)
	{
		SetMenuHover(3)
	}
	Else If (MouseCtrl = hMenuOption4 && MenuSelect != 4)
	{
		SetMenuHover(4)
	}
	Else If (MouseCtrl = hMenuOption5 && MenuSelect != 5)
	{
		SetMenuHover(5)
	}
	Else If (MouseCtrl = hMenuOption6 && MenuSelect != 6)
	{
		SetMenuHover(6)
	}
	Else If (MouseCtrl = hMenuOption7 && MenuSelect != 7)
	{
		SetMenuHover(7)
	}
	Else
	{
		SetMenuHover(-999999)
	}
}

WM_MOUSELEAVE(wParam, lParam, Msg, Hwnd)
{
	Global

	SetMenuHover(-999999)
	SetSBText("")
}

WM_LBUTTONUP(wParam, lParam, Msg, Hwnd)
{
	Global

	; Select Menu
	If (MouseCtrl = hMenuOption1)
	{
		SetMenuSelect(1)
	}
	Else If (MouseCtrl = hMenuOption2)
	{
		SetMenuSelect(2)
	}
	Else If (MouseCtrl = hMenuOption3)
	{
		SetMenuSelect(3)
	}
	Else If (MouseCtrl = hMenuOption4)
	{
		SetMenuSelect(4)
	}
	Else If (MouseCtrl = hMenuOption5)
	{
		SetMenuSelect(5)
	}
	Else If (MouseCtrl = hMenuOption6)
	{
		SetMenuSelect(6)
	}
	Else If (MouseCtrl = hMenuOption7)
	{
		SetMenuSelect(7)
	}
	Else If (MouseCtrl = hSBIcon)
	{
		Menu, StatusBarIcon, Show
	}
}

SetMenuHover(Menu)
{
	Global

	MenuHover := Menu
	GuiControl, Move, % hMenuHover, % "x" 0 " y" (32 * Menu) - 16 " w" 4 " h" 32
}

SetMenuSelect(Menu)
{
	Global

	MenuSelect := Menu
	GuiControl, Move, % hMenuSelect, % "x" 0 " y" (32 * Menu) - 16 " w" 4 " h" 32

	GuiControl,, PageTitle, % Page.Name[Menu] ; Set Page Title

	; Change Font Options For Selected Menu Text
	Loop, % Page.Name.Length()
	{
		Count := A_Index

		GuiControl, -Redraw, % "MenuOption" . A_Index

		If (A_Index = Menu)
		{
			Gui, Font, s9 c000000, Segoe UI ; Set Font Options
			GuiControl, Font, % "MenuOption" . A_Index
		}
		Else
		{
			Gui, Font, s9 c808080, Segoe UI ; Set Font Options
			GuiControl, Font, % "MenuOption" . A_Index
		}

		GuiControl, +Redraw, % "MenuOption" . A_Index

		; Hide Page Items
		Loop
		{
			GuiControlGet, OutputVar, Name, % "Page" Count "Item" A_Index

			If (OutputVar = "") ; Used To End Loop
			{
				Break
			}

			GuiControl, Hide, % "Page" Count "Item" A_Index
		}

		; Show Page Items
		Loop
		{
			GuiControlGet, OutputVar, Name, % "Page" Menu "Item" A_Index

			If (OutputVar = "") ; Used To End Loop
			{
				Break
			}

			GuiControl, Show, % "Page" Menu "Item" A_Index
		}
	}
}

SetSBText(Text)
{
	GuiControl, -Redraw, SBTextStatus ; Helps to reduce flicker
	GuiControl,, SBTextStatus, % Text
	GuiControl, +Redraw, SBTextStatus
}
; ==============================================================================